{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, Clipboard routines}
unit Clipboard;

interface

uses WinTypes, WinProcs, Buffer, TTCommon, TTTypes, TTWinMan;

procedure CBCopy(HWin: HWnd);
procedure CBStartPaste(HWin: HWnd);
procedure CBSend;
procedure CBEndPaste;

var
  CBMemHandle: THandle;
  CBMemPtr: Pointer;
  CBAddCR: boolean;
  CBByte: byte;
  CBRetrySend: boolean;
  CBRetryEcho: boolean;
  CBSendCR: boolean;
  CBDDE: boolean;

implementation

procedure CBCopy(HWin: HWnd);
var
  MemSize, TmpPtr: longint;
  i, j, k, IStart, IEnd: integer;
begin
  if not Select then exit;
  if TalkStatus=IdTalkCB then exit;

  MemSize := (SelectEnd.Y-SelectStart.Y)*(NumOfColumns+2)+SelectEnd.X-SelectStart.X+1;
  CBMemHandle := GlobalAlloc(gmem_Moveable, MemSize);
  if CBMemHandle = 0 then MessageBeep(0)
  else begin
    CBMemPtr := GlobalLock(CBMemHandle);
    if CBMemPtr = nil
    then begin
      GlobalFree(CBMemHandle);
      MessageBeep(0);
    end
    else begin
      TmpPtr := GetLinePtr(SelectStart.Y);
      k := 0;
      for j := SelectStart.Y to SelectEnd.Y do
      begin
        IStart := 0;
        IEnd := NumOfColumns-1;
        if j=SelectStart.Y then IStart := SelectStart.X;
        if j=SelectEnd.Y then IEnd := SelectEnd.X-1;

        if (IStart>0) and (IStart < NumOfColumns-1) and
           (byte(AttrBuff[TmpPtr+IStart-1]) and AttrKanji <> 0) {DBCS first byte?}
        then inc(IStart);

        while (IEnd>=0) and (CodeBuff[TmpPtr+IEnd]=#$20) do
          dec(IEnd);

        if (IEnd>=0) and (IEnd < NumOfColumns-1) and
           (byte(AttrBuff[TmpPtr+IEnd]) and AttrKanji <> 0) {DBCS first byte?}
        then inc(IEnd);

        for i := IStart to IEnd do
        begin
          PChar(CBMemPtr)[k] := CodeBuff[TmpPtr+i];
          Inc(k);
        end;
        if J < SelectEnd.Y then
        begin
          PChar(CBMemPtr)[k] := #$0d;
          Inc(k);
          PChar(CBMemPtr)[k] := #$0a;
          Inc(k);
        end;

        TmpPtr := NextLinePtr(TmpPtr);
      end;
      PChar(CBMemPtr)[k] := #0;

      GlobalUnlock(CBMemHandle);

      if OpenClipboard(HWin) then
      begin
        EmptyClipboard;
        SetClipboardData(cf_Text, CBMemHandle);
        CloseClipboard;
      end;

    end;
  end;
end;

procedure CBStartPaste(HWin: HWnd);
var
  Cf: word;
begin
  if not cv.Ready then exit;
  if TalkStatus<>IdTalkKeyb then exit;

  if IsClipboardFormatAvailable(cf_Text) then
    Cf := cf_Text
  else if IsClipboardFormatAvailable(cf_OEMText) then
    Cf := cf_OEMText
  else exit;

  if OpenClipboard(HWin) then
  begin
    CBMemHandle := GetClipboardData(Cf);
    if CBMemHandle <> 0 then
    begin
      CBMemPtr := GlobalLock(CBMemHandle);
      if CBMemPtr <> nil then TalkStatus := IdTalkCB;
    end;
  end;
  CBRetrySend := false;
  CBRetryEcho := false;
  CBSendCR := false;
  CBDDE := false;
  if TalkStatus <> IdTalkCB then CBEndPaste;
end;

procedure CBSend;
var
  c: integer;
begin
  if CBMemPtr = nil then exit;

  if CBRetrySend then
  begin
    CBRetryEcho := ts.LocalEcho>0;
    c := CommTextOut(@cv,@CBByte,1);
    CBRetrySend := c=0;
    if CBRetrySend then exit;
  end;

  if CBRetryEcho then
  begin
    c := CommTextEcho(@cv,@CBByte,1);
    CBRetryEcho := c=0;
    if CBRetryEcho then exit;
  end;

  repeat
    if CBSendCR and (PChar(CBMemPtr)[0]=#$0A) then
      CBMemPtr := @PChar(CBMemPtr)[1];

    if PChar(CBMemPtr)[0]<>#0 then
    begin
      CBByte := byte(PChar(CBMemPtr)[0]);
      CBMemPtr := @PChar(CBMemPtr)[1];
      if CBByte=$FF then {FF from TTMACRO}
      begin
        CBByte := byte(PChar(CBMemPtr)[0]);
        CBMemPtr := @PChar(CBMemPtr)[1];
        if CBByte and 1 = 0 then
          CBByte := 0
        else
          CBByte := $FF;
      end;
    end
    else if CBAddCR then
    begin
      CBAddCR := false;
      CBByte := $0d;
    end
    else begin
      CBEndPaste;
      exit;
    end;

    c := CommTextOut(@cv,@CBByte,1);
    CBSendCR := CBByte=$0D;
    CBRetrySend := c=0;
    if CBRetrySend then exit;
    if ts.LocalEcho>0 then
    begin
      c := CommTextEcho(@cv,@CBByte,1);
      CBRetryEcho := c=0;
      if CBRetryEcho then exit;
    end;
  until c=0;
end;

procedure CBEndPaste;
begin
  TalkStatus := IdTalkKeyb;
  if CBMemHandle<>0 then GlobalUnlock(CBMemHandle);

  if CBDDE then
  begin
    if CBMemHandle<>0 then GlobalFree(CBMemHandle);
  end
  else
    CloseClipboard;

  CBDDE := false;
  CBMemHandle := 0;
  CBMemPtr := nil;
  CBAddCR := false;
end;

{initialization}
begin
  CBMemHandle := 0;
  CBMemPtr := nil;
  CBAddCR := false;
end.