{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, DDE routines}
unit TTDDE;

interface
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, OWindows, Strings, DDEML, TTWinMan,
     TTCommon, Clipboard, TTTypes, TTFTypes, TTLib;
{$ELSE}
uses WinTypes, WinProcs, WObjects, Strings, DDEML, TTWinMan,
     TTCommon, Clipboard, TTTypes, TTFTypes, TTLib;
{$ENDIF}

var
  TopicName: array[0..20] of char;
  ConvH: HConv;
  AdvFlag, DdeCmnd: boolean;
  CloseTT: boolean;

procedure SetTopic;
function InitDDE: boolean;
procedure SendDDEReady;
procedure EndDDE;
procedure DDEAdv;
procedure EndDdeCmnd;
procedure SetDdeComReady(Ready: word);

implementation

uses FileSys;

const
  ServiceName = 'TERATERM';
  ItemName = 'DATA';

var
  Inst: Longint;
  DdeCallBackPtr: ^TCallback;
  Service: HSz;
  Topic: HSz;
  Item: HSz;
  HWndDdeCli: HWnd;

  ParamFileName: array[0..80] of char;
  ParamBinaryFlag: word;
  ParamAppendFlag: word;
  ParamXmodemOpt: word;

const
  CBBufSize = 83;

procedure GetClientHWnd(HWndStr: PCHAR);
var
  i: integer;
  b: BYTE;
  HCli: WORD;
begin
  HCli := 0;
  i := 0;
  b := byte(HWndStr[0]);
  while b > 0 do
  begin
    if b <= $39 then
      HCli := (HCli shl 4) + (b-$30)
    else
      HCli := (HCli shl 4) + (b-$37);
    inc(i);
    b := byte(HWndStr[i]);
  end;
  HWndDdeCli := HCli;
end;

procedure Byte2HexStr(b: BYTE; HexStr: PCHAR);
begin
  if b<$a0 then
    HexStr[0] := char($30 + (b shr 4))
  else
    HexStr[0] := char($37 + (b shr 4));
  if (b and $0f) < $0a then
    HexStr[1] := char($30 + (b and $0f))
  else
    HexStr[1] := char($37 + (b and $0f));
end;

procedure SetTopic;
var
  w: WORD;
begin;
  w := HMainWin;
  Byte2HexStr(HIBYTE(w),@TopicName[0]);
  Byte2HexStr(LOBYTE(w),@TopicName[2]);
  TopicName[4] := #0;
end;

function WildConnect(ServiceHsz, TopicHsz: HSz; ClipFmt: Word): HDDEData;
var
  Pairs: array [0..1] of THSZPair;
  Ok: Boolean;
begin
  Pairs[0].hszSvc  := Service;
  Pairs[0].hszTopic:= Topic;
  Pairs[1].hszSvc  := 0;
  Pairs[1].hszTopic:= 0;

  Ok := False;

  if (ServiceHsz= 0) and (TopicHsz = 0) then
    Ok := True                 
  else
    if (TopicHsz = 0) and (DdeCmpStringHandles(Service, ServiceHSz) = 0) then
      Ok := True
    else
      if (DdeCmpStringHandles(Topic, TopicHSz) = 0) and (ServiceHsz = 0) then
        Ok := True;

  if Ok then
    WildConnect := DdeCreateDataHandle(Inst, @Pairs, SizeOf(Pairs),
      0, 0, ClipFmt, 0)
  else
    WildConnect := 0;
end;


function AcceptRequest(ItemHSz: HSz): HDDEData;

  function Get1(var b: byte): boolean;
  begin
  with cv do begin
    if DCount>0 then
      Get1 := true
    else begin
      Get1 := false;
      exit;
    end;
    b := byte( PChar(LogBuf)[DStart] );
    inc(DStart);
    if DStart>=InBuffSize then DStart := DStart-InBuffSize;
    dec(DCount);
  end;
  end;

  function GetDataLen: longint;
  var
    b: byte;
    Len: longint;
    Start, Count: integer;
  begin
  with cv do begin
    Len := DCount;
    Start := DStart;
    Count := DCount;
    while Count>0 do
    begin
      b := byte( PChar(LogBuf)[Start] );
      if (b=0) or (b=$FF) then inc(Len);
      inc(Start);
      if Start>=InBuffSize then Start := Start-InBuffSize;
      dec(Count);
    end;
    GetDataLen := Len;
  end;
  end;

var
  b: byte;
  Unlock: boolean;
  DH: HDDEData;
  DP: pointer;
  i: integer;
begin
with cv do begin
  AcceptRequest := 0;
  if not DDELog then exit;
  if DdeCmpStringHandles(ItemHSz, Item) <> 0 then exit;
  if HLogBuf=0 then exit;

  if LogBuf=nil then
  begin
    Unlock := true;
    LogBuf := GlobalLock(HLogBuf);
    if LogBuf = nil then exit;
  end
  else Unlock := false;

  DH := DdeCreateDataHandle(Inst,nil,GetDataLen+1,0,
                            Item,CF_OEMTEXT,0);
  DP := DdeAccessData(DH,nil);
  if DP<>nil then
  begin
    i := 0;
    while Get1(b) do
    begin
      if (b=0) or (b=$FF) then
      begin
        PChar(DP)[i] := #$FF;
        PChar(DP)[i+1] := char($FE or b and 1);
        i := i + 2;
      end
      else begin
        PChar(DP)[i] := char(b);
        inc(i);
      end;
    end;
    PChar(DP)[i] := #0;
    DdeUnAccessData(DH);
  end;

  AcceptRequest := DH;

  if Unlock then
  begin
    GlobalUnlock(HLogBuf);
    LogBuf := nil;
  end;

end;
end;

function AcceptPoke(ItemHSz: HSz; ClipFmt: Word;
  Data: HDDEData): Boolean;
var
  DataPtr: pointer;
  DataSize: longint;
begin
  AcceptPoke := false;

  if TalkStatus<>IdTalkKeyb then exit;

  if (ClipFmt<>cf_Text) and (ClipFmt<>cf_OEMText) then exit;

  if DdeCmpStringHandles(ItemHSz, Item) <> 0 then exit;

  DataPtr := DdeAccessData(Data,@DataSize);
  if DataPtr=nil then exit;

  CBDDE := true;
  CBRetrySend := false;
  CBRetryEcho := false;
  CBSendCR := false;
  CBMemHandle := GlobalAlloc(GHND, CBBufSize);
  if CBMemHandle <> 0 then
  begin
    CBMemPtr := GlobalLock(CBMemHandle);
    if CBMemPtr <> nil then
    begin
      AcceptPoke := True;
      TalkStatus := IdTalkCB;
      Move(PChar(DataPtr)[0],PChar(CBMemPtr)[0],DataSize);
    end;
  end;
  if TalkStatus <> IdTalkCB then CBEndPaste;
  DdeUnaccessData(Data);
end;

const
  CmdSetHWnd      = ' ';
  CmdSetFile      = '!';
  CmdSetBinary    = '"';
  CmdSetAppend    = '#';
  CmdSetXmodemOpt = '$';

  CmdBPlusRecv    = '%';
  CmdBPlusSend    = '&';
  CmdChangeDir    = #$27; {'}
  CmdCloseWin     = '(';
  CmdKmtRecv      = ')';
  CmdKmtSend      = '*';
  CmdLogClose     = '+';
  CmdLogOpen      = ',';
  CmdLogPause     = '-';
  CmdLogStart     = '.';
  CmdLogWrite     = '/';
  CmdQVRecv       = '0';
  CmdQVSend       = '1';
  CmdSendFile     = '2';
  CmdShowMin      = '3';
  CmdShowRestore  = '4';
  CmdXmodemSend   = '5';
  CmdXmodemRecv   = '6';
  CmdZmodemSend   = '7';
  CmdZmodemRecv   = '8';

function AcceptExecute(TopicHSz: HSz; Data: HDDEData): HDDEData;
var
  Command: array[0..81] of char;
begin
  AcceptExecute := DDE_FNOTPROCESSED;
  if DdeCmpStringHandles(TopicHSz, Topic) <> 0 then exit;

  if DdeGetData(Data,@Command[0],SizeOf(Command),0) = 0 then exit;

  AcceptExecute := DDE_FACK;
  case Command[0] of
    CmdSetHWnd: begin
        GetClientHWnd(@Command[1]);
        if cv.Ready then
          SetDdeComReady(1);
      end;
    CmdSetFile: StrCopy(ParamFileName,@Command[1]);
    CmdSetBinary: ParamBinaryFlag := byte(Command[1]) and 1;
    CmdSetAppend: ParamAppendFlag := byte(Command[1]) and 1;
    CmdSetXmodemOpt: begin
        ParamXmodemOpt := byte(Command[1]) and 3;
        if ParamXmodemOpt=0 then ParamXmodemOpt := 1;
      end;

    CmdBPlusRecv:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          DdeCmnd := true;
          BPStart(IdBPReceive);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdBPlusSend:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          FileVar^.DirLen := 0;
          StrCopy(FileVar^.FullName,ParamFileName);
          FileVar^.NumFname := 1;
          DdeCmnd := true;
          BPStart(IdBPSend);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdChangeDir:
        StrCopy(ts.FileDir,ParamFileName);
    CmdCloseWin:
      CloseTT := TRUE;
    CmdKmtRecv:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          DdeCmnd := true;
          KermitStart(IdKmtReceive);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdKmtSend:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          FileVar^.DirLen := 0;
          StrCopy(FileVar^.FullName,ParamFileName);
          FileVar^.NumFname := 1;
          DdeCmnd := true;
          KermitStart(IdKmtSend);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdLogClose: if LogVar<>nil then LogEnd;
    CmdLogOpen:
        if (LogVar=nil) and NewFileVar(LogVar) then
        begin
          LogVar^.DirLen := 0;
          StrCopy(LogVar^.FullName,ParamFileName);
          ts.TransBin := ParamBinaryFlag;
          ts.Append := ParamAppendFlag;
          LogStart;
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdLogPause:
        if FLogDlg<>nil then
        begin
          FLogDlg^.Pause := true;
          FLogDlg^.ChangeButton;
        end;
    CmdLogStart:
        if FLogDlg<>nil then
        begin
          FLogDlg^.Pause := false;
          FLogDlg^.ChangeButton;
        end;
    CmdLogWrite:
        if FLogDlg<>nil then
        begin
          _lwrite(LogVar^.FileHandle,
                  ParamFileName,StrLen(ParamFileName));
          LogVar^.ByteCount :=
            LogVar^.ByteCount + StrLen(ParamFileName);
          FLogDlg^.RefreshNum;
        end;
    CmdQVRecv:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          DdeCmnd := true;
          QVStart(IdQVReceive);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdQVSend:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          FileVar^.DirLen := 0;
          StrCopy(FileVar^.FullName,ParamFileName);
          FileVar^.NumFname := 1;
          DdeCmnd := true;
          QVStart(IdQVSend);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdSendFile:
        if (SendVar=nil) and NewFileVar(SendVar) then
        begin
          SendVar^.DirLen := 0;
          StrCopy(SendVar^.FullName,ParamFileName);
          ts.TransBin := ParamBinaryFlag;
          DdeCmnd := true;
          FileSendStart;
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdShowMin: ShowWindow(HMainWin,SW_MINIMIZE);
    CmdShowRestore: ShowWindow(HMainWin,SW_RESTORE);
    CmdXmodemRecv:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          FileVar^.DirLen := 0;
          StrCopy(FileVar^.FullName,ParamFileName);
          ts.XmodemOpt := ParamXmodemOpt;
          ts.XmodemBin := ParamBinaryFlag;
          DdeCmnd := true;
          XmodemStart(IdXReceive);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdXmodemSend:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          FileVar^.DirLen := 0;
          StrCopy(FileVar^.FullName,ParamFileName);
          ts.XmodemOpt := ParamXmodemOpt;
          DdeCmnd := true;
          XmodemStart(IdXSend);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdZmodemRecv:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          DdeCmnd := true;
          ZmodemStart(IdZReceive);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
    CmdZmodemSend:
        if (FileVar=nil) and NewFileVar(FileVar) then
        begin
          FileVar^.DirLen := 0;
          StrCopy(FileVar^.FullName,ParamFileName);
          FileVar^.NumFname := 1;
          ts.XmodemBin := ParamBinaryFlag;
          DdeCmnd := true;
          ZmodemStart(IdZSend);
        end
        else begin
          AcceptExecute := DDE_FNOTPROCESSED;
        end;
  else
    AcceptExecute := DDE_FNOTPROCESSED;
  end;
end;

function DdeCallbackProc(CallType, Fmt: Word; Conv: HConv; HSz1, HSz2: HSZ;
  Data: HDDEData; Data1, Data2: Longint): HDDEData; export;
begin
  DdeCallbackProc := 0;

  case CallType of

    xtyp_WildConnect:
      DdeCallbackProc := WildConnect(HSz2, HSz1, Fmt);

    xtyp_Connect:
      if Conv = 0 then
      begin
        if (DdeCmpStringHandles(Topic, HSz1) = 0) and
           (DdeCmpStringHandles(Service, HSz2) = 0) then
        begin
          if cv.Ready then
            SetDdeComReady(1);
          DdeCallbackProc := 1;
        end;
      end;

    xtyp_Connect_Confirm:
      ConvH := Conv;

    xtyp_AdvReq, xtyp_Request:
        DdeCallBackProc := AcceptRequest(HSz2);

    xtyp_Poke:
      begin
        if AcceptPoke(HSz2, Fmt, Data) then
          DdeCallbackProc := dde_FAck;
      end;

    xtyp_AdvStart:
      begin
        if (DdeCmpStringHandles(Topic, HSz1) = 0) and
           (DdeCmpStringHandles(Item, HSz2) = 0) and
           (not AdvFlag) then
        begin
          AdvFlag := true;
          DdeCallbackProc := 1;
        end;
      end;

    xtyp_AdvStop:
      begin
        if (DdeCmpStringHandles(Topic, HSz1) = 0) and
           (DdeCmpStringHandles(Item, HSz2) = 0) and
           AdvFlag then
        begin
          AdvFlag := false;
          DdeCallbackProc := 1;
        end;
      end;
    xtyp_Disconnect:
      begin
        ConvH := 0;
        HWndDdeCli := 0;
        postmessage(HMainWin,WM_USER+MsgDdeEnd,0,0);
      end;
    xtyp_Execute:
      begin
        DdeCallBackProc := AcceptExecute(HSz1, Data);
      end;
  end;  { Case CallType }

end;

function InitDDE: boolean;
var
  Ok: boolean;
begin
  InitDDE := false;
  if ConvH<>0 then exit;

  DdeCallBackPtr:= MakeProcInstance(@DdeCallBackProc, HInstance);

  Ok := true;

  if (DdeCallBackPtr<>nil) and
     (DdeInitialize(Inst,TCallBack(DdeCallBackPtr),0,0) = dmlErr_No_Error) then
  begin
    Service:= DdeCreateStringHandle(Inst, ServiceName, cp_WinAnsi);
    Topic  := DdeCreateStringHandle(Inst, TopicName, cp_WinAnsi);
    Item   := DdeCreateStringHandle(Inst, ItemName, cp_WinAnsi);

    Ok := DdeNameService(Inst, Service, 0, dns_Register) <> 0;
  end
  else
    Ok := false;

  DdeLog := true;
  CloseTT := false;

  if Ok and cv.Ready then
    Ok := CreateLogBuf;

  if not Ok then EndDDE;
  InitDDE := Ok;
end;

procedure SendDDEReady;
begin
  GetClientHWnd(TopicName);
  PostMessage(HWndDdeCli,WM_USER+MsgDdeReady,0,0);
end;

procedure EndDDE;
begin
  if (Inst <> 0) then
  begin
    if Service <> 0 then
      DdeFreeStringHandle(Inst, Service);
    if Topic <> 0 then
      DdeFreeStringHandle(Inst, Topic);
    if Item <> 0 then
      DdeFreeStringHandle(Inst, Item);
    DdeUninitialize(Inst);
    Inst := 0;
    if DdeCallBackPtr <> nil then
      FreeProcInstance(DdeCallBackPtr);
  end;
  TopicName[0] := #0;
  ConvH := 0;
  HWndDdeCli := 0;
  AdvFlag := false;

  DDELog := false;
  FreeLogBuf;
end;

procedure DDEAdv;
begin
  if (not AdvFlag) or
     (cv.DCount=0) then exit;
    DdePostAdvise(Inst,Topic,Item);
end;

procedure EndDdeCmnd;
begin
  if (ConvH=0) or (HWndDdeCli=0) or (not DdeCmnd) then exit;
  PostMessage(HWndDdeCli,wm_User+MsgDdeCmndEnd,0,0);
  DdeCmnd := false;
end;

procedure SetDdeComReady(Ready: word);
begin
  if HWndDdeCli=0 then exit;
  PostMessage(HWndDdeCli,wm_User+MsgDdeComReady,Ready,0);
end;

begin
  TopicName[0] := #0;
  Service := 0;
  Topic := 0;
  Item := 0;
  Inst := 0;
  ConvH := 0;
  HWndDdeCli := 0;
  DdeCallBackPtr := nil;
  AdvFlag := false;
  DdeCmnd := false;
  CloseTT := false;
end.