{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTDLG.DLL, dialog boxes}
library TTDlg;
{$R TTDlg.res}
{$I teraterm.inc}

{$IFDEF Delphi}
uses Messages, WinTypes, WinProcs, WinDos, Strings,
     TTTypes, TTCommon, DlgLib, CommDlg, TTLib;
{$ELSE}
uses WinTypes, WinProcs, WinDos, Win31, Strings,
     TTTypes, TTCommon, DlgLib, CommDlg, TTLib;
{$ENDIF}

const
  Id_TermDialogJP = 100;
  Id_TermDialog = 1100;
  Id_TermWidth = 101;
  Id_TermHeight = 102;
  Id_TermIsWin = 103;
  Id_TermResize = 104;
  Id_TermCRRcv = 105;
  Id_TermCRLFRcv = 106;
  Id_TermCRSend = 107;
  Id_TermCRLFSend = 108;
  Id_TermLocalEcho = 109;
  Id_TermAnsbackText = 110;
  Id_TermAnsback = 111;
  Id_TermSJIS = 112;
  Id_TermEUC = 113;
  Id_TermJIS = 114;
  Id_TermKana = 115;
  Id_TermSJISSend = 116;
  Id_TermEUCSend = 117;
  Id_TermJISSend = 118;
  Id_TermKanaSend = 119;
  Id_TermKIN0 = 120;
  Id_TermKIN1 = 121;
  Id_TermKIN2 = 122;
  Id_TermKOut0 = 123;
  Id_TermKOut1 = 124;
  Id_TermKOut3 = 126;
  Id_TermAutoWinSwitch = 127;
  Id_TermVT100 = 128;
  Id_TermVT382 = 136;
  Id_TermHelp = 199;

  Id_WinDialog = 200;
  Id_WinTitle = 201;
  Id_WinBlock = 202;
  Id_WinVert = 203;
  Id_WinHorz = 204;
  Id_WinHideMenu = 205;
  Id_Win3D = 206;
  Id_WinColorEmu = 207;
  Id_WinScroll1 = 208;
  Id_WinScroll2 = 209;
  Id_WinScroll3 = 210;
  Id_WinText = 211;
  Id_WinBack = 212;
  Id_WinRev = 213;
  Id_WinRed = 214;
  Id_WinGreen = 215;
  Id_WinBlue = 216;
  Id_WinRedBar = 217;
  Id_WinGreenBar = 218;
  Id_WinBlueBar = 219;
  Id_WinAttrText = 220;
  Id_WinAttr = 221;
  Id_WinHelp = 299;

  Id_KeybDialogJP = 300;
  Id_KeybDialog = 1200;
  Id_KeybBS = 301;
  Id_KeybDEL = 302;
  Id_KeybIME = 303;
  Id_KeybEnable = 304;
  Id_KeybInline = 305;
  Id_KeybMeta = 306;
  Id_KeybHelp = 399;

  Id_SerialDialog = 400;
  Id_SerialPort = 401;
  Id_SerialBaud = 402;
  Id_SerialData = 403;
  Id_SerialParity = 404;
  Id_SerialStop = 405;
  Id_SerialFlow = 406;
  Id_SerialDelayChar = 407;
  Id_SerialDelayLine = 408;
  Id_SerialHelp = 499;

  Id_TCPIPDialog = 500;
  Id_TCPIPHost = 501;
  Id_TCPIPAdd = 502;
  Id_TCPIPList = 503;
  Id_TCPIPDelete = 504;
  Id_TCPIPAutoClose = 505;
  Id_TCPIPPort = 506;
  Id_TCPIPTelnet = 507;
  Id_TCPIPTermTypeLabel = 508;
  Id_TCPIPTermType = 509;
  Id_TCPIPHelp = 599;

  Id_HostDialog = 600;
  Id_HostTCPIP = 601;
  Id_HostSerial = 602;
  Id_HostNameLabel = 603;
  Id_HostName = 604;
  Id_HostTelnet = 605;
  Id_HostTCPPortLabel = 606;
  Id_HostTCPPort = 607;
  Id_HostComLabel = 608;
  Id_HostCom = 609;
  Id_HostHelp = 699;

  Id_DirDialog = 700;
  Id_DirCurrent = 701;
  Id_DirNew = 702;
  Id_DirHelp = 799;

  Id_AboutDialog = 800;
  Id_AboutMode = 801;
  Id_AboutMem = 802;
  Id_AboutRes = 803;

  Id_FontDlg = 900;
  Id_FontBold = 901;

  Id_GenDialog = 1000;
  Id_GenTCP = 1001;
  Id_GenSerial = 1002;
  Id_GenEnglish = 1003;
  Id_GenJapanese = 1004;
  Id_GenHelp = 1099;

function TermDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  ts: PTTSet;
  w: word;
  Temp: array[0..80] of char;
begin
  TermDlg := True;
  case Message of
    wm_InitDialog:
      begin
        ts := PTTSet(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);
        if not ts^.Ok then {English mode}
          {Japanese terminal -> English terminal}
          case ts^.TerminalId of
            IdVT100J: ts^.TerminalId := IdVT100;
            IdVT102J: ts^.TerminalId := IdVT102;
            IdVT220J: ts^.TerminalId := IdVT282;
          end;

        SetDlgItemInt(Dialog,ID_TermWidth,ts^.TerminalWidth,false);
        SendDlgItemMessage(Dialog, id_TermWidth, em_LimitText,3, 0);

        SetDlgItemInt(Dialog,Id_TermHeight,ts^.TerminalHeight,false);
        SendDlgItemMessage(Dialog, id_TermHeight, em_LimitText,3, 0);

        SetRB(Dialog,ts^.TermIsWin,Id_TermIsWin,Id_TermIsWin);
        SetRB(Dialog,ts^.AutoWinResize,Id_TermResize,Id_TermResize);
        if ts^.TermIsWin>0 then
          DisableDlgItem(Dialog,id_TermResize,Id_TermResize);

        SetRB(Dialog,ts^.CRReceive,Id_TermCRRcv,Id_TermCRLFRcv);

        SetRB(Dialog,ts^.CRSend,Id_TermCRSend,Id_TermCRLFSend);

        if ts^.BPAuto then
          DisableDlgItem(Dialog,id_TermAnsbackText,Id_TermAnsback)
        else begin
          Str2Hex(ts^.Answerback,Temp,ts^.AnswerbackLen,
                  SizeOf(Temp)-1,false);
          SetDlgItemText(Dialog, Id_TermAnsback, Temp);
          SendDlgItemMessage(Dialog, id_TermAnsback, em_LimitText,
                           SizeOf(Temp) - 1, 0);
        end;

        SetRB(Dialog,ts^.LocalEcho,Id_TermLocalEcho,Id_TermLocalEcho);

        SetRB(Dialog,ts^.KanjiCode,Id_TermSJIS,Id_TermJIS);

        if ts^.KanjiCode<>IdJIS then
          DisableDlgItem(Dialog,id_TermKana,Id_TermKana);

        SetRB(Dialog,ts^.JIS7Katakana,Id_TermKana,Id_TermKana);

        SetRB(Dialog,ts^.KanjiCodeSend,Id_TermSJISSend,Id_TermJISSend);

        if ts^.KanjiCodeSend<>IdJIS then
          DisableDlgItem(Dialog,id_TermKanaSend,Id_TermKOut3);

        SetRB(Dialog,ts^.JIS7KatakanaSend,Id_TermKanaSend,Id_TermKanaSend);

        SetRB(Dialog,ts^.KanjiIN,Id_TermKIN1,Id_TermKIN2);

        if not ts^.AllowWrongSequence then
          DisableDlgItem(Dialog,id_TermKOut3,Id_TermKOut3);

        SetRB(Dialog,ts^.KanjiOut,Id_TermKOut1,Id_TermKOut3);

        SetRB(Dialog,ts^.AutoWinSwitch,Id_TermAutoWinSwitch,Id_TermAutoWinSwitch);

        SetRB(Dialog,ts^.TerminalID,Id_TermVT100,Id_TermVT382);

        Exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if ts<>nil then
          begin
            ts^.Ok := true;

            ts^.TerminalWidth := GetDlgItemInt(Dialog,Id_TermWidth,nil,false);
            if ts^.TerminalWidth<1 then ts^.TerminalWidth := 1;
            if ts^.TerminalWidth>500 then ts^.TerminalWidth := 500;

            ts^.TerminalHeight := GetDlgItemInt(Dialog,Id_TermHeight,nil,false);
            if ts^.TerminalHeight<1 then ts^.TerminalHeight := 1;
            if ts^.TerminalHeight>500 then ts^.TerminalHeight := 500;

            GetRB(Dialog,ts^.TermIsWin,Id_TermIsWin,Id_TermIsWin);
            GetRB(Dialog,ts^.AutoWinResize,Id_TermResize,Id_TermResize);

            GetRB(Dialog,ts^.CRReceive,Id_TermCRRcv,Id_TermCRLFRcv);

            GetRB(Dialog,ts^.CRSend,Id_TermCRSend,Id_TermCRLFSend);

            if not ts^.BPAuto then
            begin
              GetDlgItemText(Dialog, id_TermAnsback,Temp,SizeOf(Temp));
              ts^.AnswerbackLen :=
                Hex2Str(Temp,ts^.Answerback,SizeOf(ts^.Answerback));
            end;

            GetRB(Dialog,ts^.LocalEcho,Id_TermLocalEcho,Id_TermLocalEcho);

            GetRB(Dialog,ts^.KanjiCode,Id_TermSJIS,Id_TermJIS);

            GetRB(Dialog,ts^.JIS7Katakana,Id_TermKana,Id_TermKana);

            GetRB(Dialog,ts^.KanjiCodeSend,Id_TermSJISSend,Id_TermJISSend);

            GetRB(Dialog,ts^.JIS7KatakanaSend,Id_TermKanaSend,Id_TermKanaSend);

            GetRB(Dialog,ts^.KanjiIN,Id_TermKIN1,Id_TermKIN2);

            GetRB(Dialog,ts^.KanjiOut,Id_TermKOut1,Id_TermKOut3);

            GetRB(Dialog,ts^.AutoWinSwitch,Id_TermAutoWinSwitch,Id_TermAutoWinSwitch);

            GetRB(Dialog,ts^.TerminalID,Id_TermVT100,Id_TermVT382);

          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if ts<>nil then ts^.Ok := false;
          EndDialog(Dialog, 0);
          exit;
        end;
        id_TermIsWin: begin
          GetRB(Dialog,w,Id_TermIsWin,Id_TermIsWin);
          if w=0 then
            EnableDlgItem(Dialog,id_TermResize,Id_TermResize)
          else
            DisableDlgItem(Dialog,id_TermResize,Id_TermResize);
        end;
        id_TermSJIS..Id_TermEUC: begin
          DisableDlgItem(Dialog,id_TermKana,Id_TermKana);
        end;
        id_TermJIS: begin
          EnableDlgItem(Dialog,id_TermKana,Id_TermKana);
        end;
        id_TermSJISSend..Id_TermEUCSend: begin
          DisableDlgItem(Dialog,id_TermKanaSend,Id_TermKOut3);
        end;
        id_TermJISSend: begin
          EnableDlgItem(Dialog,id_TermKanaSend,Id_TermKOut3);
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if not ts^.AllowWrongSequence then
            DisableDlgItem(Dialog,id_TermKOut3,Id_TermKOut3);
        end;
        id_TermHelp: PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  TermDlg := False;
end;

function WinDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  ts: PTTSet;
  Wnd, HRed, HGreen, HBlue: HWnd;
  i, IAttr, IOffset: integer;
  w: word;
  FN: array[0..160] of char;
  SearchRec: TSearchRec;
  DC: HDC;

  procedure DispSample;
  var
    i,x,y: integer;
    Text, Back: TColorRef;
    DX: array[0..2] of integer;
    Metrics: TTextMetric;
    Rect, TestRect: TRect;
    FW,FH: integer;
  begin
    DC := GetDC(Dialog);
    Text := RGB(ts^.TmpColor[IAttr,0],
                ts^.TmpColor[IAttr,1],
                ts^.TmpColor[IAttr,2]);
    Text := GetNearestColor(DC, Text);
    Back := RGB(ts^.TmpColor[IAttr,3],
                ts^.TmpColor[IAttr,4],
                ts^.TmpColor[IAttr,5]);
    Back := GetNearestColor(DC, Back);
    SetTextColor(Dc, Text);
    SetBkColor(Dc, Back);
    SelectObject(Dc,ts^.SampleFont);
    GetTextMetrics(DC, Metrics);
    FW := Metrics.tmAveCharWidth;
    FH := Metrics.tmHeight;
    for i := 0 to 2 do DX[i] := FW;
    GetClientRect(Dialog,Rect);
    TestRect.left := Rect.left + round((Rect.right-Rect.left)*0.65);
    TestRect.right := Rect.left + round((Rect.right-Rect.left)*0.93);
    TestRect.top := Rect.top + round((Rect.bottom-Rect.top)*0.54);
    TestRect.bottom := Rect.top + round((Rect.bottom-Rect.top)*0.94);
    x := round((TestRect.left+TestRect.right) / 2 - FW * 1.5);
    y := (TestRect.top+TestRect.bottom-FH) div 2;
    ExtTextOut(DC, x,y, 6, @TestRect, 'ABC', 3, @DX);
    ReleaseDC(Dialog,DC);
  end;

  procedure ChangeColor;
  begin
    SetDlgItemInt(Dialog,Id_WinRed,ts^.TmpColor[IAttr,IOffset],false);
    SetDlgItemInt(Dialog,Id_WinGreen,ts^.TmpColor[IAttr,IOffset+1],false);
    SetDlgItemInt(Dialog,Id_WinBlue,ts^.TmpColor[IAttr,IOffset+2],false);

    DispSample;
  end;

  procedure ChangeSB;
  begin
    SetScrollPos(HRed,SB_CTL,ts^.TmpColor[IAttr,IOffset+0],true);
    SetScrollPos(HGreen,SB_CTL,ts^.TmpColor[IAttr,IOffset+1],true);
    SetScrollPos(HBlue,SB_CTL,ts^.TmpColor[IAttr,IOffset+2],true);
    ChangeColor;
  end;

  procedure RestoreVar;
  begin
    ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
    HRed := GetDlgItem(Dialog, Id_WinRedBar);
    HGreen := GetDlgItem(Dialog, Id_WinGreenBar);
    HBlue := GetDlgItem(Dialog, Id_WinBlueBar);
    GetRB(Dialog,word(i),Id_WinText,Id_WinBack);
    if i=2 then IOffset := 3
           else IOffset := 0;
    if (ts<>nil) and ts^.VTFlag then
      IAttr := SendDlgItemMessage(Dialog, id_WinAttr, cb_GetCurSel,
                                  0,0)
    else
      IAttr := 0;
  end;

begin
  WinDlg := True;
  case Message of
    wm_InitDialog: begin
        ts := PTTSet(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);
        with ts^ do begin

        Ok := false;

        SetDlgItemText(Dialog, Id_WinTitle, Title);
        SendDlgItemMessage(Dialog, id_WinTitle, em_LimitText,
                           SizeOf(Title)-1, 0);

        SetRB(Dialog,PopupMenu,Id_WinHideMenu,Id_WinHideMenu);
        if HideTitle=0 then
          EnableDlgItem(Dialog,id_WinHideMenu,Id_WinHideMenu);         

        GetSystemDirectory(FN,SizeOf(FN));
        StrCat(FN,'\CTL3D.DLL');
        FindFirst(FN,faAnyFile,SearchRec);
        if DosError <> 0 then
          DisableDlgItem(Dialog, id_Win3D,Id_Win3D)
        else
          SetRB(Dialog,Dlg3D,Id_Win3D,Id_Win3D);

        if VTFlag then
        begin
          ShowDlgItem(Dialog,id_WinScroll1,Id_WinScroll3);
          SetRB(Dialog,EnableScrollBuff,Id_WinScroll1,Id_WinScroll1);
          SetDlgItemInt(Dialog,Id_WinScroll2,ScrollBuffMax,false);
          SendDlgItemMessage(Dialog, id_WinScroll2, em_LimitText,4, 0);
          if EnableScrollBuff=0 then          
            DisableDlgItem(Dialog,id_WinScroll2,Id_WinScroll3);
          for i := 0 to 1 do
          begin
            TmpColor[0,i*3]   := GetRValue(VTColor[i]);
            TmpColor[0,i*3+1] := GetGValue(VTColor[i]);
            TmpColor[0,i*3+2] := GetBValue(VTColor[i]);
            TmpColor[1,i*3]   := GetRValue(VTBoldColor[i]);
            TmpColor[1,i*3+1] := GetGValue(VTBoldColor[i]);
            TmpColor[1,i*3+2] := GetBValue(VTBoldColor[i]);
            TmpColor[2,i*3]   := GetRValue(VTBlinkColor[i]);
            TmpColor[2,i*3+1] := GetGValue(VTBlinkColor[i]);
            TmpColor[2,i*3+2] := GetBValue(VTBlinkColor[i]);
          end;
          ShowDlgItem(Dialog,id_WinAttrText,Id_WinAttr);
          SendDlgItemMessage(Dialog, id_WinAttr, cb_AddString,
                             0, longint(PChar('Normal')));
          SendDlgItemMessage(Dialog, id_WinAttr, cb_AddString,
                             0, longint(PChar('Bold')));
          SendDlgItemMessage(Dialog, id_WinAttr, cb_AddString,
                             0, longint(PChar('Blink')));
          SendDlgItemMessage(Dialog, id_WinAttr, cb_SetCurSel,
                             0,0);
        end
        else begin
          for i := 0 to 1 do
          begin
            ts^.TmpColor[0,i*3]   := GetRValue(ts^.TEKColor[i]);
            ts^.TmpColor[0,i*3+1] := GetGValue(ts^.TEKColor[i]);
            ts^.TmpColor[0,i*3+2] := GetBValue(ts^.TEKColor[i]);
          end;
          ShowDlgItem(Dialog,id_WinColorEmu,Id_WinColorEmu);
          SetRB(Dialog,ts^.TEKColorEmu,Id_WinColorEmu,Id_WinColorEmu);
        end;
        SetRB(Dialog,1,Id_WinText,Id_WinBack);

        SetRB(Dialog,ts^.CursorShape,Id_WinBlock,Id_WinHorz);

        IAttr := 0;
        IOffset := 0;

        HRed := GetDlgItem(Dialog, Id_WinRedBar);
        SetScrollRange(HRed,SB_CTL,0,255,true);

        HGreen := GetDlgItem(Dialog, Id_WinGreenBar);
        SetScrollRange(HGreen,SB_CTL,0,255,true);

        HBlue := GetDlgItem(Dialog, Id_WinBlueBar);
        SetScrollRange(HBlue,SB_CTL,0,255,true);

        ChangeSB;

        end;
        Exit;
      end;
    wm_Command:
      begin
        RestoreVar;
        case wParam of
          id_Ok: begin
            if ts<>nil then
            begin
            with ts^ do begin
              Ok := true;

              GetDlgItemText(Dialog,id_WinTitle,Title,SizeOf(Title));
              if HideTitle=0 then
                GetRB(Dialog,PopupMenu,Id_WinHideMenu,Id_WinHideMenu);
              GetRB(Dialog,Dlg3D,Id_Win3D,Id_Win3D);

              DC := GetDC(Dialog);
              if VTFlag then
              begin
                GetRB(Dialog,EnableScrollBuff,Id_WinScroll1,Id_WinScroll1);
                if EnableScrollBuff>0 then
                begin
                  ScrollBuffMax :=
                    GetDlgItemInt(Dialog,Id_WinScroll2,nil,false);
                  if ScrollBuffMax>2000 then
                    ScrollBuffMax := 2000;
                end;
                for i := 0 to 1 do
                begin
                  VTColor[i] :=
                    RGB(TmpColor[0,i*3],
                        TmpColor[0,i*3+1],
                        TmpColor[0,i*3+2]);
                  VTBoldColor[i] :=
                    RGB(TmpColor[1,i*3],
                        TmpColor[1,i*3+1],
                        TmpColor[1,i*3+2]);
                  VTBlinkColor[i] :=
                    RGB(TmpColor[2,i*3],
                        TmpColor[2,i*3+1],
                        TmpColor[2,i*3+2]);
                  VTColor[i] := GetNearestColor(DC,VTColor[i]);
                  VTBoldColor[i] := GetNearestColor(DC,VTBoldColor[i]);
                  VTBlinkColor[i] := GetNearestColor(DC,VTBlinkColor[i]);
                end;
              end
              else begin
                for i := 0 to 1 do
                begin
                  TEKColor[i] :=
                    RGB(TmpColor[0,i*3],
                        TmpColor[0,i*3+1],
                        TmpColor[0,i*3+2]);
                  TEKColor[i] := GetNearestColor(DC,TEKColor[i]);
                end;
                GetRB(Dialog,TEKColorEmu,Id_WinColorEmu,Id_WinColorEmu);
              end;
              ReleaseDC(Dialog,DC);

              GetRB(Dialog,ts^.CursorShape,Id_WinBlock,Id_WinHorz);

            end;
            end;
            EndDialog(Dialog, 1);
            exit;
          end;
          id_Cancel: begin
            EndDialog(Dialog, 0);
            exit;
          end;
          id_WinScroll1: begin
            if ts=nil then exit;
            GetRB(Dialog,w,Id_WinScroll1,Id_WinScroll1);
            if w>0 then
              EnableDlgItem(Dialog,id_WinScroll2,Id_WinScroll3)
            else
              DisableDlgItem(Dialog,id_WinScroll2,Id_WinScroll3);
          end;
          id_WinText: begin
            if ts=nil then exit;
            IOffset := 0;
            ChangeSB;
          end;
          id_WinBack: begin
            if ts=nil then exit;
            IOffset := 3;
            ChangeSB;
          end;
          id_WinRev: begin
            if ts=nil then exit;
            with ts^ do begin
              i := TmpColor[IAttr,0];
              TmpColor[IAttr,0] := TmpColor[IAttr,3];
              TmpColor[IAttr,3] := i;
              i := TmpColor[IAttr,1];
              TmpColor[IAttr,1] := TmpColor[IAttr,4];
              TmpColor[IAttr,4] := i;
              i := TmpColor[IAttr,2];
              TmpColor[IAttr,2] := TmpColor[IAttr,5];
              TmpColor[IAttr,5] := i;
            end;
            ChangeSB;
          end;
          id_WinAttr: if ts<>nil then ChangeSB;
          id_WinHelp: PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
        end;
      end;

    wm_Paint: begin
      RestoreVar;
      if ts=nil then exit;
      DispSample;
    end;

    wm_HScroll: begin
      RestoreVar;
      if ts=nil then exit;
      with ts^ do begin

      Wnd := HiWord(lParam);
      if Wnd = HRed then i := IOffset
      else if Wnd = HGreen then i := IOffset + 1
      else if Wnd = HBlue then i := IOffset + 2
      else exit;

      case wParam of
        SB_Bottom:        TmpColor[IAttr,i] := 255;
        SB_LineDown:      inc(TmpColor[IAttr,i]);
        SB_LineUp:        dec(TmpColor[IAttr,i]);
        SB_PageDown:      TmpColor[IAttr,i] := TmpColor[IAttr,i] + 16;
        SB_PageUp:        TmpColor[IAttr,i] := TmpColor[IAttr,i] - 16;
        SB_ThumbPosition: TmpColor[IAttr,i] := LoWord(lParam);
        SB_ThumbTrack:    TmpColor[IAttr,i] := LoWord(lParam);
        SB_Top:           TmpColor[IAttr,i] := 0;
      end;
      if integer(TmpColor[IAttr,i]) < 0 then
        TmpColor[IAttr,i] := 0;
      if TmpColor[IAttr,i] > 255 then
        TmpColor[IAttr,i] := 255;

      SetScrollPos(Wnd,SB_CTL,TmpColor[IAttr,i],true);

      end;

      ChangeColor;
      exit;
    end;

  end;
  WinDlg := False;
end;

function KeybDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  ts: PTTSet;
  w: word;
begin
  KeybDlg := True;
  case Message of
    wm_InitDialog:
      begin
        ts := PTTSet(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);

        SetRB(Dialog,ts^.BSKey,Id_KeybBS,Id_KeybDEL);

        SetRB(Dialog,ts^.UseIME,Id_KeybEnable,Id_KeybEnable);
        SetRB(Dialog,ts^.IMEInline,Id_KeybInline,Id_KeybInline);
        if ts^.UseIME=0 then
          DisableDlgItem(Dialog,id_KeybInline,Id_KeybInline);
        SetRB(Dialog,ts^.MetaKey,Id_KeybMeta,Id_KeybMeta);
        Exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if ts<>nil then
          begin
            ts^.Ok := true;

            GetRB(Dialog,ts^.BSKey,Id_KeybBS,Id_KeybDEL);

            GetRB(Dialog,ts^.UseIME,Id_KeybEnable,Id_KeybEnable);

            GetRB(Dialog,ts^.IMEInline,Id_KeybInline,Id_KeybInline);

            GetRB(Dialog,ts^.MetaKey,Id_KeybMeta,Id_KeybMeta);

          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if ts<>nil then ts^.Ok := false;
          EndDialog(Dialog, 0);
          exit;
        end;
        id_KeybEnable: begin
          GetRB(Dialog,w,Id_KeybEnable,Id_KeybEnable);
          if w=0 then
            DisableDlgItem(Dialog,id_KeybInline,Id_KeybInline)
          else
            EnableDlgItem(Dialog,id_KeybInline,Id_KeybInline);
        end;
        id_KeybHelp: PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  KeybDlg := False;
end;

const
  PortList: array[0..4] of PChar = (
    'COM1','COM2','COM3','COM4',nil);
  BaudList: array[0..10] of PChar = (
    '110','300','600','1200','2400','4800','9600',
    '19200','38400','57600',nil);
  DataList: array[0..2] of PChar = (
    '7 bit','8 bit',nil);
  ParityList: array[0..3] of PChar = (
    'even','odd','none',nil);
  StopList: array[0..2] of PChar = (
    '1 bit','2 bit',nil);
  FlowList: array[0..3] of PChar = (
    'Xon/Xoff','hardware','none',nil);

function SerialDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  ts: PTTSet;
begin
  SerialDlg := True;
  case Message of
    wm_InitDialog:
      begin
        ts := PTTSet(lParam);
        ts^.Ok := false;
        SetWindowLong(Dialog, DWL_USER, lParam);

        SetDropDownList(Dialog, Id_SerialPort, @PortList, ts^.ComPort);
        SetDropDownList(Dialog, Id_SerialBaud, @BaudList, ts^.Baud);
        SetDropDownList(Dialog, Id_SerialData, @DataList, ts^.DataBit);
        SetDropDownList(Dialog, Id_SerialParity, @ParityList, ts^.Parity);
        SetDropDownList(Dialog, Id_SerialStop, @StopList, ts^.StopBit);
        SetDropDownList(Dialog, Id_SerialFlow, @FlowList, ts^.Flow);

        SetDlgItemInt(Dialog,ID_SerialDelayChar,ts^.DelayPerChar,false);
        SendDlgItemMessage(Dialog, id_SerialDelayChar, em_LimitText,4, 0);

        SetDlgItemInt(Dialog,ID_SerialDelayLine,ts^.DelayPerLine,false);
        SendDlgItemMessage(Dialog, id_SerialDelayLine, em_LimitText,4, 0);

        Exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if ts<>nil then
          begin
            ts^.Ok := true;

	    ts^.ComPort := GetCurSel(Dialog, Id_SerialPort);
	    ts^.Baud := GetCurSel(Dialog, Id_SerialBaud);
	    ts^.DataBit := GetCurSel(Dialog, Id_SerialData);
	    ts^.Parity := GetCurSel(Dialog, Id_SerialParity);
	    ts^.StopBit := GetCurSel(Dialog, Id_SerialStop);
	    ts^.Flow := GetCurSel(Dialog, Id_SerialFlow);

            ts^.DelayPerChar := GetDlgItemInt(Dialog,ID_SerialDelayChar,nil,false);

            ts^.DelayPerLine := GetDlgItemInt(Dialog,ID_SerialDelayLine,nil,false);

            ts^.PortType := IdSerial;
          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          EndDialog(Dialog, 0);
          exit;
        end;
        id_SerialHelp: PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  SerialDlg := False;
end;

function TCPIPDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  ts: PTTSet;
  EntName: array[0..6] of char;
  TempHost: array[0..HostNameMaxLength] of char;
  i, Index: integer;
  HControl: HWnd;
  Ok: bool;
begin
  TCPIPDlg := True;
  case Message of
    wm_InitDialog:
      begin
        ts := PTTSet(lParam);
        ts^.Ok := false;
        SetWindowLong(Dialog, DWL_USER, lParam);

        SendDlgItemMessage(Dialog, id_TCPIPHost, em_LimitText,
                           HostNameMaxLength-1, 0);

        StrCopy(EntName,'Host');

        i := 1;
        repeat
          if i < 10 then
          begin
            EntName[4] := char(i+$30);
            EntName[5] := #0;
          end
          else begin
            EntName[4] := char(i div 10 + $30);
            EntName[5] := char(i mod 10 + $30);
            EntName[6] := #0;
          end;

          GetPrivateProfileString('Hosts',EntName,'',
                                  TempHost,SizeOf(TempHost),ts^.SetupFName);
          if StrLen(TempHost) > 0 then
            SendDlgItemMessage(Dialog, id_TCPIPList, lb_AddString,
                               0, longint(@TempHost));
          inc(i)
        until (i > 99) or (StrLen(TempHost)=0);

        SetRB(Dialog,ts^.AutoWinClose,Id_TCPIPAutoClose,Id_TCPIPAutoClose);

        SetDlgItemInt(Dialog,ID_TCPIPPort,ts^.TCPPort,false);

        SetRB(Dialog,ts^.Telnet,Id_TCPIPTelnet,Id_TCPIPTelnet);

        SetDlgItemText(Dialog, Id_TCPIPTermType, ts^.TermType);
        SendDlgItemMessage(Dialog, id_TCPIPTermType, em_LimitText,
                           SizeOf(ts^.TermType)-1, 0);

        if ts^.Telnet=0 then
          DisableDlgItem(Dialog,id_TCPIPTermTypeLabel,Id_TCPIPTermType);

        Exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          ts := PTTSet(GetWindowLong(Dialog,DWL_USER));
          if ts<>nil then
          begin
            ts^.Ok := true;

            WritePrivateProfileString('Hosts',nil,nil,ts^.SetupFName);

            HControl := GetDlgItem(Dialog, Id_TCPIPList);
            Index := SendMessage(HControl, lb_getcount, 0, 0);
            if Index=lb_err then Index := 0;
            if Index>99 then Index := 99;

            StrCopy(EntName,'Host');
            for i := 1 to Index do
            begin
              SendDlgItemMessage(Dialog, id_TCPIPList, lb_GetText,
                                 i-1, longint(@TempHost));

              if i < 10 then
              begin
                EntName[4] := char(i+$30);
                EntName[5] := #0;
              end
              else begin
                EntName[4] := char(i div 10 + $30);
                EntName[5] := char(i mod 10 + $30);
                EntName[6] := #0;
              end;
              WritePrivateProfileString('Hosts',EntName,TempHost,ts^.SetupFName);
            end;

            GetRB(Dialog,ts^.AutoWinClose,Id_TCPIPAutoClose,Id_TCPIPAutoClose);

            ts^.TCPPort := GetDlgItemInt(Dialog,Id_TCPIPPort,@Ok,false);
            if not Ok then ts^.TCPPort := 23;

            GetRB(Dialog,ts^.Telnet,Id_TCPIPTelnet,Id_TCPIPTelnet);

            GetDlgItemText(Dialog, id_TCPIPTermType, ts^.TermType,
                         SizeOf(ts^.TermType));

          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          EndDialog(Dialog, 0);
          exit;
        end;
        id_TCPIPHost:
          if HiWord(lParam)=en_change then
          begin
            HControl := HWnd(LoWord(lParam));
            GetDlgItemText(Dialog, id_TCPIPHost, TempHost, SizeOf(TempHost));
            if StrLen(TempHost)=0 then
              DisableDlgItem(Dialog,id_TCPIPAdd,Id_TCPIPAdd)
            else
              EnableDlgItem(Dialog,id_TCPIPAdd,Id_TCPIPAdd);
          end;
        id_TCPIPAdd: begin
          GetDlgItemText(Dialog, id_TCPIPHost, TempHost, SizeOf(TempHost));
          if StrLen(TempHost)>0 then
          begin
            HControl := GetDlgItem(Dialog, Id_TCPIPList);
            Index := SendMessage(HControl, lb_getcursel, 0, 0);
            if Index=lb_err then Index:=0;

            SendDlgItemMessage(Dialog, id_TCPIPList, lb_InsertString,
                               Index, longint(@TempHost));
            
            SetDlgItemText(Dialog, id_TCPIPHost, #0);
          end;
        end;
        id_TCPIPList:
          if HiWord(lParam)=lbn_selchange then
            EnableDlgItem(Dialog,id_TCPIPDelete,Id_TCPIPDelete);

        id_TCPIPDelete: begin
          HControl := GetDlgItem(Dialog, Id_TCPIPList);
          Index := SendMessage(HControl, lb_getcursel, 0, 0);
          if Index=lb_err then exit;
          SendDlgItemMessage(Dialog, id_TCPIPList, lb_GetText,
                             Index, longint(@TempHost));
          SendDlgItemMessage(Dialog, id_TCPIPList, lb_DeleteString,
                             Index, 0);
          SetDlgItemText(Dialog, id_TCPIPHost, TempHost);
          DisableDlgItem(Dialog,id_TCPIPDelete,Id_TCPIPDelete);
        end;
        id_TCPIPTelnet: begin
          GetRB(Dialog,word(i),Id_TCPIPTelnet,Id_TCPIPTelnet);
          if i=1 then
          begin
            EnableDlgItem(Dialog,id_TCPIPTermTypeLabel,Id_TCPIPTermType);
            SetDlgItemInt(Dialog,Id_TCPIPPort,23,false);
          end
          else
            DisableDlgItem(Dialog,id_TCPIPTermTypeLabel,Id_TCPIPTermType);
        end;

        id_TCPIPHelp: PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  TCPIPDlg := False;
end;

function HostDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  GetHNRec: PGetHNRec;
  EntName: array[0..6] of char;
  TempHost: array[0..HostNameMaxLength] of char;
  i: integer;
  Ok: bool;
begin
  HostDlg := True;
  case Message of
    wm_InitDialog:
      begin
        GetHNRec := PGetHNRec(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);

        if GetHNRec^.PortType=IdFile then
          GetHNRec^.PortType := IdTCPIP;
        SetRB(Dialog,GetHNRec^.PortType,Id_HostTCPIP,Id_HostSerial);

        StrCopy(EntName,'Host');

        i := 1;
        repeat
          if i < 10 then
          begin
            EntName[4] := char(i+$30);
            EntName[5] := #0;
          end
          else begin
            EntName[4] := char(i div 10 + $30);
            EntName[5] := char(i mod 10 + $30);
            EntName[6] := #0;
          end;

          GetPrivateProfileString('Hosts',EntName,'',
                                  TempHost,SizeOf(TempHost),GetHNRec^.SetupFN);
          if StrLen(TempHost) > 0 then
            SendDlgItemMessage(Dialog, id_HostName, cb_AddString,
                               0, longint(@TempHost));
          inc(i)
        until (i > 99) or (StrLen(TempHost)=0);

        SendDlgItemMessage(Dialog, id_HostName, em_LimitText,
                           HostNameMaxLength-1, 0);

        SendDlgItemMessage(Dialog, id_HostName, cb_SetCurSel,0,0);

        SetDlgItemInt(Dialog,ID_HostTCPPort,GetHNRec^.TCPPort,false);

        if (GetCOMFlag and 1) = 0 then
          SendDlgItemMessage(Dialog, id_HostCom, cb_AddString,
                             0, longint(PChar('COM1')));
        if (GetCOMFlag and 2) = 0 then
          SendDlgItemMessage(Dialog, id_HostCom, cb_AddString,
                             0, longint(PChar('COM2')));
        if (GetCOMFlag and 4) = 0 then
          SendDlgItemMessage(Dialog, id_HostCom, cb_AddString,
                             0, longint(PChar('COM3')));
        if (GetCOMFlag and 8) = 0 then
          SendDlgItemMessage(Dialog, id_HostCom, cb_AddString,
                             0, longint(PChar('COM4')));

        SetRB(Dialog,GetHNRec^.Telnet,Id_HostTelnet,Id_HostTelnet);

        SendDlgItemMessage(Dialog, id_HostCom, cb_SetCurSel,0,0);

        {All com ports are already used}
        if GetCOMFlag = 15 then GetHNRec^.PortType := IdTCPIP;

        if GetHNRec^.PortType=IdTCPIP then
          DisableDlgItem(Dialog,id_HostComLabel,Id_HostCom)
        else
          DisableDlgItem(Dialog,id_HostNameLabel,Id_HostTCPPort);

        Exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          GetHNRec := PGetHNRec(GetWindowLong(Dialog,DWL_USER));
          if GetHNRec<>nil then
          begin
            GetRB(Dialog,GetHNRec^.PortType,Id_HostTCPIP,Id_HostSerial);
            if GetHNRec^.PortType=IdTCPIP then
              GetDlgItemText(Dialog, id_HostName, GetHNRec^.HostName, HostNameMaxLength)
            else
              GetHNRec^.HostName[0] := #0;
            GetRB(Dialog,GetHNRec^.Telnet,Id_HostTelnet,Id_HostTelnet);
            GetHNRec^.TCPPort := GetDlgItemInt(Dialog,Id_HostTCPPort,@Ok,false);
            if not Ok then GetHNRec^.TCPPort := 65535;
            FillChar(EntName,SizeOf(EntName),0);
            GetDlgItemText(Dialog, id_HostCom, EntName, SizeOf(EntName)-1);
            GetHNRec^.COMPort := byte(EntName[3])-$30;
            if GetHNRec^.COMPort > 4 then GetHNRec^.COMPort := 0;
          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          EndDialog(Dialog, 0);
          exit;
        end;
        id_HostTCPIP: begin
          EnableDlgItem(Dialog,id_HostNameLabel,Id_HostTCPPort);
          DisableDlgItem(Dialog,id_HostComLabel,Id_HostCom);
        end;
        id_HostSerial: begin
          if (GetCOMFlag<>15) then
            EnableDlgItem(Dialog,id_HostComLabel,Id_HostCom);
          DisableDlgItem(Dialog,id_HostNameLabel,Id_HostTCPPort);
        end;
        id_HostTelnet: begin
          GetRB(Dialog,word(i),Id_HostTelnet,Id_HostTelnet);
          if i=1 then
            SetDlgItemInt(Dialog,ID_HostTCPPort,23,false);
        end;
        id_HostHelp:
          PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  HostDlg := False;
end;

function DirDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  CurDir: PChar;
  HomeDir, TmpDir: array[0..fsDirectory] of char;
begin
  DirDlg := True;
  case Message of
    wm_InitDialog:
      begin
        CurDir := PCHAR(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);

        SetDlgItemText(Dialog, Id_DirCurrent, CurDir);
        SendDlgItemMessage(Dialog, id_DirNew, em_LimitText,
                           fsDirectory-1, 0);
        Exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
	  CurDir := PCHAR(GetWindowLong(Dialog,DWL_USER));
          if CurDir<>nil then
          begin
            GetCurDir(HomeDir,0);
            SetCurDir(CurDir);
            GetDlgItemText(Dialog, id_DirNew, TmpDir,
                         SizeOf(TmpDir));
            if StrLen(TmpDir)>0 then
            begin
              SetCurDir(TmpDir);
              if DosError>0 then
              begin
                messagebox(Dialog,'Cannot find directory','Tera Term: Error',mb_iconexclamation);
                SetCurDir(HomeDir);
                exit;
              end;
              GetCurDir(CurDir,0);
            end;
            SetCurDir(HomeDir);
          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          EndDialog(Dialog, 0);
          exit;
        end;
        id_DirHelp:
          PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  DirDlg := False;
end;

function AboutDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  NumStr: string[15];
  FreeStr: array[0..20] of char;
  TmpStr: array[0..15] of char;
  Free: longint;
  n: word;
begin
  AboutDlg := True;
  case Message of
    wm_InitDialog:
      begin
        if GetWinFlags and WF_ENHANCED = WF_ENHANCED then
          SetDlgItemText(Dialog, Id_AboutMode, 'Enhanced mode');
        FreeStr[0] := #0;
        {free memory in KB}
        Free := GetFreeSpace(0) div 1024;
        Str(Free, NumStr);
        StrPCopy(FreeStr,NumStr);
        n := StrLen(FreeStr);
        if n>6 then
        begin
          StrCopy(TmpStr,@FreeStr[n-6]);
          FreeStr[n-6] := #0;
          StrCat(FreeStr,',');
          StrCat(FreeStr,TmpStr);
        end;
        n := StrLen(FreeStr);
        if n>3 then
        begin
          StrCopy(TmpStr,@FreeStr[n-3]);
          FreeStr[n-3] := #0;
          StrCat(FreeStr,',');
          StrCat(FreeStr,TmpStr);
        end;
        StrCat(FreeStr,' KB');
        SetDlgItemText(Dialog, Id_AboutMem, FreeStr);

        {free system resources in %}
        Str(GetFreeSystemResources(GFSR_SystemResources), NumStr);
        StrPCopy(TmpStr,NumStr);
        StrCat(TmpStr,' %');
        SetDlgItemText(Dialog, Id_AboutRes, TmpStr);
        exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          EndDialog(Dialog, 0);
          exit;
        end;
      end;
  end;
  AboutDlg := False;
end;

function GenDlg(Dialog: HWnd; Message, WParam: Word;
  LParam: Longint): Bool; export;
var
  Param: PLongint;
  L, H: word;
begin
  GenDlg := True;
  case Message of
    wm_InitDialog:
      begin
        Param := PLongint(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);
        L := LoWord(Param^);
        {IdFile -> IdTCPIP}
        if L<>IdSerial then L := IdTCPIP;
        H := HiWord(Param^);
        SetRB(Dialog,L,Id_GenTCP,Id_GenSerial);
        SetRB(Dialog,H,Id_GenEnglish,Id_GenJapanese);
        exit;
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
	  Param := PLongint(GetWindowLong(Dialog,DWL_USER));
          if Param<>nil then
          begin
            GetRB(Dialog,L,Id_GenTCP,Id_GenSerial);
            GetRB(Dialog,H,Id_GenEnglish,Id_GenJapanese);
            Param^ := MAKELONG(L,H);
          end;
          EndDialog(Dialog, 1);
          exit;
        end;
        id_Cancel: begin
          EndDialog(Dialog, 0);
          exit;
        end;
        id_GenHelp:
          PostMessage(GetParent(Dialog),WM_User+MsgDlgHelp2,0,0);
      end;
  end;
  GenDlg := False;
end;


function SetupTerminal(WndParent: HWnd; ts: PTTSet; Language: Word): Bool; export;
var
  TermProc: TFarProc;
begin
  TermProc := MakeProcInstance(@TermDlg, HInstance);
  ts^.Ok := Language=IdJapanese; {Japanese flag}
  if ts^.Ok then
    SetupTerminal := Bool( DialogBoxParam(HInstance,PChar(Id_TermDialogJP), WndParent, TermProc, longint(ts)) )
  else
    SetupTerminal := Bool( DialogBoxParam(HInstance,PChar(Id_TermDialog), WndParent, TermProc, longint(ts)) );
  FreeProcInstance(TermProc);
  Exit;
end;

function SetupWin(WndParent: HWnd; ts: PTTSet): Bool; export;
var
  WinProc: TFarProc;
begin
  WinProc := MakeProcInstance(@WinDlg, HInstance);
  SetupWin := Bool( DialogBoxParam(HInstance,PChar(Id_WinDialog), WndParent, WinProc, longint(ts)) );
  FreeProcInstance(WinProc);
  Exit;
end;

function SetupKeyboard(WndParent: HWnd; ts: PTTSet; Language: Word): Bool; export;
var
  KeybProc: TFarProc;
begin
  KeybProc := MakeProcInstance(@KeybDlg, HInstance);
  ts^.Ok := Language=IdJapanese; {Japanese flag}
  if ts^.Ok then
    SetupKeyboard := Bool( DialogBoxParam(HInstance,PChar(Id_KeybDialogJP), WndParent, KeybProc, longint(ts)) )
  else
    SetupKeyboard := Bool( DialogBoxParam(HInstance,PChar(Id_KeybDialog), WndParent, KeybProc, longint(ts)) );
  FreeProcInstance(KeybProc);
  Exit;
end;

function SetupSerialPort(WndParent: HWnd; ts: PTTSet): Bool; export;
var
  SerialProc: TFarProc;
begin
  SerialProc := MakeProcInstance(@SerialDlg, HInstance);
  SetupSerialPort := Bool( DialogBoxParam(HInstance,PChar(Id_SerialDialog), WndParent, SerialProc, longint(ts)) );
  FreeProcInstance(SerialProc);
  Exit;
end;

function SetupTCPIP(WndParent: HWnd; ts: PTTSet): Bool; export;
var
  TCPIPProc: TFarProc;
begin
  TCPIPProc := MakeProcInstance(@TCPIPDlg, HInstance);
  SetupTCPIP := Bool( DialogBoxParam(HInstance,PChar(Id_TCPIPDialog), WndParent, TCPIPProc, longint(ts)) );
  FreeProcInstance(TCPIPProc);
  Exit;
end;

function GetHostName(WndParent: HWnd; GetHNRec: PGetHNRec): Bool; export;
var
  HostProc: TFarProc;
begin
  HostProc := MakeProcInstance(@HostDlg, HInstance);
  GetHostName := Bool( DialogBoxParam(HInstance,PChar(Id_HostDialog), WndParent, HostProc, longint(GetHNRec)) );
  FreeProcInstance(HostProc);
  Exit;
end;

function ChangeDirectory(WndParent: HWnd; CurDir: PChar): Bool; export;
var
  DirProc: TFarProc;
begin
  DirProc := MakeProcInstance(@DirDlg, HInstance);
  ChangeDirectory := Bool( DialogBoxParam(HInstance,PChar(Id_DirDialog), WndParent, DirProc, longint(CurDir)) );
  FreeProcInstance(DirProc);
  exit;
end;

function AboutDialog(WndParent: HWnd): Bool; export;
var
  AboutProc: TFarProc;
begin
  AboutProc := MakeProcInstance(@AboutDlg, HInstance);
  AboutDialog := Bool( DialogBox(HInstance,PChar(Id_AboutDialog), WndParent, AboutProc) );
  FreeProcInstance(AboutProc);
  exit;
end;

function TFontHook(Dialog: HWnd; Message, WParam: Word; LParam: Longint): Bool; export;
var
  cf: PChooseFont;
begin
  case Message of
    wm_InitDialog:
      begin
        cf := PCHOOSEFONT(lParam);
        SetWindowLong(Dialog, DWL_USER, lParam);

        ShowDlgItem(Dialog,Id_FontBold,Id_FontBold);
        SetRB(Dialog,word(cf^.lCustData and 1)
              ,Id_FontBold,Id_FontBold);
      end;
    wm_Command:
      case wParam of
        id_Ok: begin
          cf := PCHOOSEFONT(GetWindowLong(Dialog, DWL_USER));
          if cf<>nil then
          begin
            GetRB(Dialog,word(cf^.lCustData),
              Id_FontBold,Id_FontBold);
          end;
        end;
        id_Cancel: ;
      end;
  end;
  TFontHook := False;
end;

function ChooseFontDlg(WndParent: HWnd; LogFont: PLogFont; Bold: PWord): bool; export;
var
  ChooseRec: TChooseFont;
  Ok: bool;
begin
  FillChar(ChooseRec, SizeOf(ChooseRec), #0);
  with ChooseRec do
  begin
    lStructSize:= SizeOf(TChooseFont);
    hwndOwner  := WndParent;
    lpLogFont  := LogFont;
    Flags      := cf_ScreenFonts or cf_InitToLogFontStruct or
                  cf_FixedPitchOnly or cf_ShowHelp or cf_EnableTemplate;
    if Bold<>nil then
    begin
      flags := flags or cf_EnableHook;
      @lpfnHook := MakeProcInstance(@TFontHook, HInstance);
      if Bold^>0 then
        lCustData := 1
      else
        lCustData := 0;
    end;
    lpTemplateName := PChar(Id_FontDlg);
    nFontType := regular_fonttype;
  end;
  ChooseRec.hInstance := HInstance;
  Ok := ChooseFont(ChooseRec);
  if Ok and (Bold<>nil) then
    Bold^ := ChooseRec.lCustData and 1;

  ChooseFontDlg := Ok;
end;

function SetupGeneral(WndParent: HWnd; Port,Language: PWord): Bool; export;
var
  GenProc: TFarProc;
  LParam: longint;
begin
  GenProc := MakeProcInstance(@GenDlg, HInstance);
  LParam := MAKELONG(Port^,Language^);
  if Bool( DialogBoxParam(HInstance,PChar(Id_GenDialog), WndParent, GenProc, longint(@LParam)) )
  then begin
    SetupGeneral := true;
    Port^ := LoWord(LParam);
    Language^ := HiWord(LParam);
  end
  else
    SetupGeneral := false;
  FreeProcInstance(GenProc);
  exit;
end;


exports

  SetupTerminal   index 1,
  SetupWin        index 2,
  SetupKeyboard   index 3,
  SetupSerialPort index 4,
  SetupTCPIP      index 5,
  GetHostName     index 6,
  ChangeDirectory index 7,
  AboutDialog     index 8,
  ChooseFontDlg   index 9,
  SetupGeneral    index 10;

begin
end.